/**
 */
package PatternLanguage.Operations;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see PatternLanguage.Operations.OperationsFactory
 * @model kind="package"
 * @generated
 */
public interface OperationsPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "Operations";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://mdserg.se.ui.ir/patternlanguage/Operations/";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "Operations";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	OperationsPackage eINSTANCE = PatternLanguage.Operations.impl.OperationsPackageImpl.init();

	/**
	 * The meta object id for the '{@link PatternLanguage.Operations.impl.getInstanceImpl <em>get Instance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see PatternLanguage.Operations.impl.getInstanceImpl
	 * @see PatternLanguage.Operations.impl.OperationsPackageImpl#getgetInstance()
	 * @generated
	 */
	int GET_INSTANCE = 0;

	/**
	 * The feature id for the '<em><b>Base Operation</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_INSTANCE__BASE_OPERATION = 0;

	/**
	 * The number of structural features of the '<em>get Instance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_INSTANCE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>get Instance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_INSTANCE_OPERATION_COUNT = 0;


	/**
	 * Returns the meta object for class '{@link PatternLanguage.Operations.getInstance <em>get Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>get Instance</em>'.
	 * @see PatternLanguage.Operations.getInstance
	 * @generated
	 */
	EClass getgetInstance();

	/**
	 * Returns the meta object for the reference '{@link PatternLanguage.Operations.getInstance#getBase_Operation <em>Base Operation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Base Operation</em>'.
	 * @see PatternLanguage.Operations.getInstance#getBase_Operation()
	 * @see #getgetInstance()
	 * @generated
	 */
	EReference getgetInstance_Base_Operation();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	OperationsFactory getOperationsFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link PatternLanguage.Operations.impl.getInstanceImpl <em>get Instance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see PatternLanguage.Operations.impl.getInstanceImpl
		 * @see PatternLanguage.Operations.impl.OperationsPackageImpl#getgetInstance()
		 * @generated
		 */
		EClass GET_INSTANCE = eINSTANCE.getgetInstance();

		/**
		 * The meta object literal for the '<em><b>Base Operation</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GET_INSTANCE__BASE_OPERATION = eINSTANCE.getgetInstance_Base_Operation();

	}

} //OperationsPackage
